'------------------------------------------------------------
'Quellprogramm : JULIA5.BAS
'------------------------------------------------------------
'Berechnung der Julia-Menge der komplexen Iteration
'z(n+1) = z(n)^2 + c mit dem Level-Set-Algorithmus.
'Wahlweise koennen Niveaulinien dargestellt werden.
'------------------------------------------------------------

SCREEN 12                  'VGA, 640 x 480 Pixel, 16 Farben
px = 600: py = 400         'Bildschirmbereich

CLS
PRINT "Berechnung der Julia-Menge"
PRINT "=========================="
PRINT
PRINT "Das Programm stellt die Julia-Menge grafisch dar."
PRINT "Eingabewerte sind die Komponenten a und b"
PRINT "des Parameters c = (a,b) sowie die x- und y-"
PRINT "Koordinaten fr den dynamischen Bereich z = (x,y)."

marke:
PRINT
PRINT "Parameter c = (a,b)"
INPUT "a = ", a
INPUT "b = ", b
PRINT
'z-Ebene, z = (x,y)               'mathematischer Bereich
PRINT "Dynamischer Bereich"
INPUT "xmin = ", xmin
INPUT "xmax = ", xmax
INPUT "ymin = ", ymin
ymax = 2 / 3 * (xmax - xmin) + ymin
PRINT
PRINT "Maximale Anzahl der Iterationen:"
INPUT "nmax = ", nmax
PRINT
INPUT "Darstellung von Niveaulinien (j/n) ? ", nl$
PRINT
INPUT "Gitternetz (j/n) ? ", gi$

xschritt = (xmax - xmin) / px       'Schrittweite
yschritt = (ymax - ymin) / py

r = 2 + SQR(a ^ 2 + b ^ 2)          'Fluchtschranke
r2 = r ^ 2

CLS
'Berechnung der Julia-Menge durch Abtasten der
'Bildschirmpunkte
FOR sx = 0 TO px                    'BildschirmSpalten
   x = xmin + sx * xschritt
   FOR zy = 0 TO py                 'BildschirmZeilen
      y = ymax - zy * yschritt
      x1 = x: y1 = y                'Startwert z0
      FOR n = 1 TO nmax             'Iteration
         xx = x1 * x1 - y1 * y1 + a      'Hilfsgroesse
         y1 = 2 * x1 * y1 + b            'Imaginaerteil
         x1 = xx                         'Realteil
         IF x1 * x1 + y1 * y1 > r2 THEN n0 = n: EXIT FOR
      NEXT n
      'Punktausgabe
      IF nl$ = "j" THEN
        IF INT(n0 / 2) = n0 / 2 THEN PSET (sx, zy)
        'Darstellung der Niveaulinien
           IF x1 * x1 + y1 * y1 <= r2 THEN PSET (sx, zy), 12
        ELSE
           IF x1 * x1 + y1 * y1 <= r2 THEN PSET (sx, zy), 12
        END IF
   NEXT zy
NEXT sx
               
'Gitternetz
IF gi$ = "j" THEN
   FOR i = 0 TO px STEP px / 30
      LINE (i, py)-(i, 0)
   NEXT i
   FOR j = 0 TO py STEP py / 20
      LINE (0, j)-(px, j)
   NEXT j
END IF

LOCATE 27
PRINT "a = "; a; ";"; " b = "; b
PRINT "xmin = "; xmin; ";"; " xmax = "; xmax; ";";
PRINT " ymin = "; ymin; ";"; " ymax = "; ymax; ";";
PRINT " nmax = "; nmax
INPUT "Weitere Berechnung (j,n) "; antwort$
IF antwort$ = "j" THEN GOTO marke

END

                                                                                

