'------------------------------------------------------------
'Quellprogramm : MANDEL1.BAS
'------------------------------------------------------------
'Berechnung der Mandelbrot-Menge der komplexen Iteration
'z(n+1) = z(n)^2 + c mit dem Level-Set-Algorithmus.
'Wahlweise koennen Niveaulinien dargestellt werden.
'------------------------------------------------------------

SCREEN 12                  'VGA, 640 x 480 Pixel, 16 Farben
px = 600: py = 400         'Bildschirmbereich

CLS
PRINT "Berechnung der Mandelbrot-Menge"
PRINT "==============================="
PRINT
PRINT "Das Programm stellt die Mandelbrot-Menge grafisch dar."
PRINT "Eingabeparameter sind die Komponenten a und b"
PRINT "fr den komplexen Bereich der Konstanten c = (a,b)"

marke:
PRINT
'c-Ebene, c = (a,b)                 'mathematischer Bereich
INPUT "amin = ", amin
INPUT "amax = ", amax
INPUT "bmin = ", bmin
bmax = 2 / 3 * (amax - amin) + bmin
PRINT
PRINT "Maximale Anzahl der Iterationen:"
INPUT "nmax = ", nmax
PRINT
INPUT "Darstellung von Niveaulinien (j/n) ? ", nl$
PRINT
INPUT "Gitternetz (j/n) ? ", gi$

aschritt = (amax - amin) / px       'Schrittweite
bschritt = (bmax - bmin) / py

CLS
'Berechnung der Mandelbrot-Menge durch Abtasten der
'Bildschirmpunkte
FOR sx = 0 TO px                    'BildschirmSpalten
   a = amin + sx * aschritt
   FOR zy = 0 TO py                 'BildschirmZeilen
      b = bmax - zy * bschritt
      x = 0: y = 0                  'Startwert z0=0
      FOR n = 1 TO nmax             'Iteration
         xx = x * x - y * y + a        'Hilfsgroesse
         y = 2 * x * y + b             'Imaginaerteil
         x = xx                        'Realteil
         IF x * x + y * y > 4 THEN n0 = n: EXIT FOR
         'Der Punkt c = (a, b) gehoert nicht zur Mandelbrot-Menge
      NEXT n
      'Punktausgabe
      IF nl$ = "j" THEN
        IF INT(n0 / 2) = n0 / 2 THEN PSET (sx, zy)
        'Darstellung der Niveaulinien
           IF x * x + y * y <= 4 THEN PSET (sx, zy), 12
           'Der Punkt c = (a, b) gehoert zur Mandelbrot-Menge
        ELSE
           IF x * x + y * y <= 4 THEN PSET (sx, zy), 12
           'Der Punkt c = (a, b) gehoert zur Mandelbrot-Menge
      END IF
   NEXT zy
NEXT sx
               
'Gitternetz
IF gi$ = "j" THEN
   FOR i = 0 TO px STEP px / 30
      LINE (i, py)-(i, 0)
   NEXT i
   FOR j = 0 TO py STEP py / 20
      LINE (0, j)-(px, j)
   NEXT j
END IF

LOCATE 28
PRINT "amin = "; amin; ";"; " amax = "; amax; ";";
PRINT " bmin = "; bmin; ";"; " bmax = "; bmax; ";";
PRINT " nmax = "; nmax
INPUT "Weitere Berechnung (j,n) "; antwort$
IF antwort$ = "j" THEN GOTO marke

END

                                                                                

