'-----------------------------------------------
'Quellprogramm: ORBIT1.BAS
'-----------------------------------------------
'Berechnung des Orbits (der Bahn) der
'Iteration x(n+1) = x(n)^2 + a
'-----------------------------------------------
'Eingabewerte:
a = -.5         'Parameter a
x = 1.36        'Startwert x0
n = 20          'Anzahl der Iterationen nmax
'-----------------------------------------------

 SCREEN 12     'VGA, 640 x 480 Pixel, 16 Farben
 px = 620      'Festlegung der Bildschirmpunkte (Bildschirmbereich)
 py = 420

 xmin = -2: xmax = 2              'mathematischer Bereich
 xschritt = (xmax - xmin) / py    'Schrittweite

                                
 zy = (xmax - x) / xschritt       'Transformationsgleichung
 CIRCLE (30, zy), 2, 14

 FOR sx = 30 + (px - 50) / n TO px - 20 STEP (px - 50) / n  'Iteration
   x = x ^ 2 + a
   IF x > xmax THEN
      PRINT "Iteration ausserhalb des Rechenbereichs"
      EXIT FOR
   END IF
   zy = (xmax - x) / xschritt
   'PSET (sx, zy), 12
   LINE -(sx, zy), 12
 NEXT sx

 LINE (0, 0)-(0, py)                'Skalierung
 FOR j = 0 TO py STEP py / 20
   LINE (0, j)-(5, j)
 NEXT j
 LINE (px, 0)-(px, py)
 FOR j = 0 TO py STEP py / 20
   LINE (px, j)-(px - 5, j)
 NEXT j

 END

